#include <iostream>
#include <bits/stdc++.h>

using namespace std;


int main()
{
    int t, m, n;

    cin >> t;

    for(int j = 0; j < t; j++){
        cin >> m >> n;

        int p = 1;
        long long int a[m], r[m], b[n], x;

        for(int i = 0; i < m; i++)
            cin >> a[i];

        /*r = abs(a[0]-a[1]);
        for(int i = 2; i < m-1; i++){
            if(abs(a[i]-a[i-1]) < r)
                r = abs(a[i]-a[i-1]);
        }*/
        for(int i = 1; i < m; i++)
            r[i-1] = abs(a[i]-a[i-1]);

        /*sort(r, r + m-1);*/
        long long int minr = r[0];
        for(int i = 0; i < m-1; i++)
            if(r[i] < minr)
                minr = r[i];

        x = a[0]%minr;
        for(int i = 0 ; i < n; i++)
            cin >> b[i];

        for(int i = 0; i < n && p; i++)
            if(b[i]%minr == x)
                p = 0;

        cout << p << endl;

    }
    return 0;
}